#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
int t, n, m;
ll a[75099], b[75099];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> t;
    while(t--) {
        cin >> n >> m;
        for(int i=0; i<n; ++i) cin >> a[i];
        for(int i=0; i<m; ++i) cin >> b[i];
        sort(a, a+n);
        ll d=a[1]-a[0];
        for(int i=1; i<n-1; ++i) {
            d=__gcd(d, a[i+1]-a[i]);
        }
        ll ost=a[0]%d;
        bool moze=true;
        for(int i=0; i<m; ++i) {
            if(b[i]%d==ost) {
                moze=false;
                break;
            }
        }
        cout << moze << "\n";
    }
    return 0;
}